Name:		mosml
Version:	2.01
Release:	9%{?dist}
Summary:	Moscow ML

Group:		Development/Languages
License:	GPL/ATT/INRIA/Distributable
URL:		http://www.dina.kvl.dk/~sestoft/mosml.html
Source:		http://www.dina.kvl.dk/~sestoft/mosml/mos201src.tar.gz
Patch0:		mosml-install.patch
Patch1:		mosml-fpic.patch
Patch2:		mosml-shared.patch
Patch3:		mosml-ld.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	gdbm-devel
BuildRequires:  gmp-devel
BuildRequires:	libpng-devel
BuildRequires:  gd-devel
BuildRequires:  zlib-devel
BuildRequires:	postgresql-devel
ExcludeArch:    x86_64

%define mosmldir %{_libdir}/mosml

%description
Moscow ML provides a light-weight implementation of full Standard ML,
including Modules and some extensions.  Standard ML is a strict
functional language widely used in teaching and research.


%package devel
Summary:        Development files for Moscow ML
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description devel
Development files for Moscow ML.
Install this if you want to compile native modules.


%package docs
Summary:        Documentation for Moscow ML
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description docs
Documentation for Moscow ML.


%package examples
Summary:	Examples for Moscow ML
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description examples
Examples for Moscow ML.


# %package mysql
# Summary:        MySQL module for Moscow ML
# Group:          Development/Languages
# Requires:	%{name} = %{version}-%{release}, mysql >= 0:3.23.58
# BuildRequires:  mysql-devel

# %description mysql
# Module for Moscow ML for accessing MySQL databases.


%package pg
Summary:        PostgreSQL module for Moscow ML
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description pg
Binary module for Moscow ML for accessing PostgreSQL databases.


%package gd
Summary:        GD module for Moscow ML
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description gd
Binary module for Moscow ML for using GD.


%package gdbm
Summary:        GDBM module for Moscow ML
Group:          Development/Languages
Requires:       %{name} = %{version}-%{release}

%description gdbm
Binary module for Moscow ML for using GDBM.


%prep
%setup -q -n mosml
%patch0 -p1 -b .install
%patch1 -p1 -b .fpic
%patch2 -p1 -b .shared
%patch3 -p1 -b .ld
%define makeflags BINDIR=%{mosmldir}/bin LIBDIR=%{mosmldir}/lib ROPT="$RPM_OPT_FLAGS"
# Build errors in these libraries, disable for now
perl -pi -e 's|cd mmysql.*|true|' src/dynlibs/Makefile
perl -pi -e 's|cd msocket.*|true|' src/dynlibs/Makefile
perl -pi -e 's|\${HOME}/mosml|%{_libdir}/mosml|' tools/Makefile.stub
find . -name \*.sml | xargs chmod 0644
# remove empty file
rm -f examples/units/Evaluate.sm


%build
cd src
make %makeflags MOSMLHOME=$RPM_BUILD_ROOT%{mosmldir} world
mkdir -p $RPM_BUILD_ROOT%{mosmldir}/{bin,lib}
make %makeflags MOSMLHOME=$RPM_BUILD_ROOT%{mosmldir} DESTDIR=$RPM_BUILD_ROOT install
cd dynlibs
make MOSMLHOME=$RPM_BUILD_ROOT%{mosmldir}


%install
rm -rf $RPM_BUILD_ROOT
pushd src
make %makeflags MOSMLHOME=$RPM_BUILD_ROOT%{mosmldir} DESTDIR=$RPM_BUILD_ROOT install
pushd dynlibs
make %makeflags MOSMLHOME=$RPM_BUILD_ROOT%{mosmldir} DESTDIR=$RPM_BUILD_ROOT install
popd
popd

cp tools/Makefile.stub $RPM_BUILD_ROOT%{mosmldir}/tools

# remove w32 readmes and makefiles
find examples -name "*.w32" | xargs rm -f

# Put installed doc in an rpm manner
cp -a $RPM_BUILD_ROOT%{mosmldir}/doc .
rm -rf $RPM_BUILD_ROOT%{mosmldir}/doc

# Link binaries to the standard search path /usr/bin
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cd $RPM_BUILD_ROOT%{mosmldir}/bin
for x in * 
do
  ln -sf ../%{_lib}/mosml/bin/$x $RPM_BUILD_ROOT%{_bindir}/$x
done

# Fix minor install problem:
rm -f $RPM_BUILD_ROOT%{mosmldir}/lib/camlrunm
ln -s ../bin/camlrunm $RPM_BUILD_ROOT%{mosmldir}/lib/camlrunm

# move include files to %%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_includedir}/mosml
mv $RPM_BUILD_ROOT%{_libdir}/mosml/include $RPM_BUILD_ROOT%{_includedir}/mosml
mv $RPM_BUILD_ROOT%{_libdir}/mosml/config $RPM_BUILD_ROOT%{_includedir}/mosml


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%{mosmldir}
%{_bindir}/*
#%exclude %{_libdir}/mosml/lib/Mysql.*
#%exclude %{_libdir}/mosml/lib/libmmysql.so
%exclude %{mosmldir}/lib/libmpq.so
%exclude %{mosmldir}/lib/libmgdbm.so
%exclude %{mosmldir}/lib/libmgd.so
%doc README copyrght/*


%files devel
%defattr(-,root,root,-)
%{_includedir}/*


%files examples
%defattr(-,root,root,-)
%doc examples/*


%files pg
%defattr(-,root,root,-)
%{mosmldir}/lib/libmpq.so


%files gdbm
%defattr(-,root,root,-)
%{mosmldir}/lib/libmgdbm.so


%files gd
%defattr(-,root,root,-)
%{mosmldir}/lib/libmgd.so


%files docs
%defattr(-,root,root,-)
%doc doc/*


%changelog
* Fri Jul 28 2006 Gerard Milmeister <gemi@bluewin.ch> - 2.01-9
- fixed links to lib dir

* Mon May  1 2006 Gerard Milmeister <gemi@bluewin.ch> - 2.01-8
- sanitized shared library linking (mosml-ld.patch)
- split off docs package

* Tue Jan  3 2006 Gerard Milmeister <gemi@bluewin.ch> - 2.01-5
- separated devel package for native module development
- added gd-devel buildreq

* Thu Feb 24 2005 Gerard Milmeister <gemi@bluewin.ch> - 0:2.01-1
- New Version 2.01

* Wed Oct 15 2003 Gerard Milmeister <gemi@bluewin.ch> - 0:2.00-0.fdr.1
- First Fedora release

* Mon Aug 7 2000 Jakob Lichtenberg <jl@itu.dk>
- re-build with new mos20src distribution (same version!)

* Fri Jun 30 2000 Jakob Lichtenberg <jl@itu.dk>
- initial release
